<?php

//////////////////////////////////////////////////////////////////////////
//
//	TagTemplate v2.00
//
//	Please see the README.htm documentation
//
//////////////////////////////////////////////////////////////////////////

//
//	Deprecated - don't use these anymore.  They're here for backwards compatibility, and for internal use
//
define("TMPLT_BEFORE",		"BEFORE");
define("TMPLT_BETWEEN",		"BETWEEN");
define("TMPLT_AFTER",		"AFTER");
define("TMPLT_TAG",			"TAG");

function tt_echo($s, $count = 0)
{
	echo $s;
}

function tt_ignore($s, $count = 0)
{
}

function tt_capture($s, $count = 0)
{
	global $tt_output;

	$tt_output .= $s;
}

class TagTemplate
{
	var $tt_lines = array();
	var $tt_in_func = "tt_echo";
	var $tt_out_func = "tt_echo";

	function tt_set_input_file($filename)
	{
		if (is_readable($filename))
			$this->tt_lines = file($filename);
	}

	function tt_set_input_string($s)
	{
		$this->tt_lines[] = $s;
	}

	function tt_set_input_array($a)
	{
		$this->tt_lines = $a;
	}

	function tt_set_in_func($func)
	{
		$this->tt_in_func = $func;
	}

	function tt_set_out_func($func)
	{
		$this->tt_out_func = $func;
	}

	function run_func($func, $output, $count)
	{
		if (is_array($func))
		{
			$obj = $func[0];
			$fname = $func[1];
			$obj->$fname($output, $count);
		}
		else
			$func($output, $count);
	}

	function tt_parse($tag)
	{
		global $tt_output;

		$where = TMPLT_BEFORE;
		$count = 0;
		$tt_output = "";		// just in case it's being used
		foreach ($this->tt_lines as $index => $line)
		{
			$get_another_line = false;

			while (true)
			{
				unset($new_where);
				unset($to_output);

				switch ($where)
				{
				case TMPLT_BEFORE:
					if ($found = stristr($line, "<" . $tag))
					{
						$output = substr($line, 0, strlen($line) - strlen($found));
						$line = substr($found, strlen($tag)+1);		// skip over the "<tagname"
						$new_where = TMPLT_TAG;
					}
					else
					{
						$output = $line;
						$get_another_line = true;
					}
					$this->run_func($this->tt_out_func, $output, $count);
					break;

				case TMPLT_TAG:
					// nothing $to_output
					$count++;
					if ($found = stristr($line, ">"))
					{
						$line = substr($found, 1);		// skip the ">"
						$new_where = TMPLT_BETWEEN;
					}
					else
						$get_another_line = true;
					break;

				case TMPLT_BETWEEN:
					if ($found = stristr($line, "</" . $tag))
					{
						//
						//	the ">" of the end-tag must immeditately follow the pattern! (hence the +3)
						//
					    $output = substr($line, 0, strlen($line) - strlen($found));
						$line = substr($found, strlen($tag)+3);
						$new_where = TMPLT_BEFORE;
					}
					else
					{
						$output = $line;
						$get_another_line = true;
					}
					$this->run_func($this->tt_in_func, $output, $count);
					break;
				}

				if (isset($new_where))		// changing state
					$where = $new_where;

				if ($line == "")
					$get_another_line = true;

				if ($get_another_line)
					break;					// will go out to the outer loop and get another line
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////
//
//	For Backwards compatibility with 1.00 and 1.01
//
//////////////////////////////////////////////////////////////////////////

function my_out_func($s, $count)
{
	global $tt_want;
	global $tt_output;

	if (
		($count == 0 && $tt_want == TMPLT_BEFORE)
		||
		($count > 0 && $tt_want == TMPLT_AFTER)
	   )
		$tt_output .= $s;
}

//
//	tag_template() function
//
//	Tested and working in PHP 4
//
//	Return a string that represents a portion of the given template file
//	The returned string can be echo'd
//	Which portion of the template depends on the value of the "$want" parameter:
//		- "BEFORE":  You get everything before the first "$tag" in the file (such as <xyz>)
//		- "BETWEEN": You get everything enclosed in the given "$tag" (but not the tag itself)
//		- "AFTER":   You get everything after the closing "$tag" (such as </xyz>)
//	$tag is case-independent
//
function tag_template($filename, $tag, $want)
{
	global $tt_want;
	global $tt_output;

	$tt = new TagTemplate;

	$tt->tt_set_input_file($filename);
	switch ($want)
	{
		case TMPLT_BEFORE:
		case TMPLT_AFTER:
			$tt->tt_set_in_func("tt_ignore");
			$tt->tt_set_out_func("my_out_func");
			break;
		case TMPLT_BETWEEN:
			$tt->tt_set_in_func("tt_capture");
			$tt->tt_set_out_func("tt_ignore");
			break;
	}
	$tt_want = $want;

	$tt->tt_parse($tag);

	return $tt_output;
}

?>